/*******************************************************************************
 * FoxGameMP_OS generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxGameMP_OS extends FoxGameMP_TDM
    native
    config(Game)
    hidecategories(Navigation,Movement,Collision);

struct native WaveEnemyData
{
    var Pawn EnemyPawn;
    var bool bDropAmmo;
    var name PresetName;
    var int SquadIdx;
    var class<FoxPickup_Token> TokenClass;

    structdefaultproperties
    {
        EnemyPawn=none
        bDropAmmo=false
        PresetName=None
        SquadIdx=0
        TokenClass=none
    }
};

struct native WaveEnemyQueue
{
    var AIInfo AIToSpawn;
    var WaveEnemyData EnemyData;

    structdefaultproperties
    {
        AIToSpawn=AIPresetName=BasicMelee,Weight=1,PointValue=1,MaxAllowed=0,bWantsSquadLeader=false,bOverrideTargetingInfo=false,TargetingInfo=bOverrideTargetClosest=true,CloseRangeThreshold=512.0,bOverrideTargetAttacker=true,HowRecentlySeconds=2.0,Stickiness=10.0,Preference=ETargetPreference.ETTB_Closest,Filters=(159),
/* Exception thrown while deserializing TargetingInfo
System.ArgumentException: Der angeforderte Wert "__OnActivateItem__Delegate_855638015" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */,
/* Exception thrown while deserializing AIToSpawn
System.ArgumentException: Der angeforderte Wert "3D Mode_16777215" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
        EnemyData=(EnemyPawn=none,bDropAmmo=false,PresetName=None,SquadIdx=0,TokenClass=none)
    }
};

var private FoxAIWaveInfo WaveInfo;
var private array<WaveEnemyQueue> SpawnQueue;
var private array<WaveEnemyData> RemainingWaveEnemies;
var private array<FoxGameObject_WeaponDepot> WeaponDepots;
var private FoxGameObject_WeaponDepot EnabledDepot;
var private transient bool bFirstWaveSpawned;
var bool bCompletedAllWavesSuccessfully;
var private bool bAllowingRespawns;
var private transient int CurrentAISquadIdx;
var private transient FoxGRI_OS CachedGRI;
var private transient float CurrentHealthModifier;
var private PlayerStartVariables PSV_Ambush;
var private float SpawnQueueRate;
var int WaveDelaySeconds;
var private const int AmmoDropRate;
var private float AIPoolPoints;
var private float TotalAIPoolPointsThisSubWave;
var private int NumObjectives;
var private int ActivatedObjectiveCount;
var private array<FoxGameObject_OSPoint> Objectives;
var private int CurrentObjectiveIndex;
var const config int EstablishingScanningUIBufferTime;
var const config int EstablishingProgressTime;
var const config int MinimumUIScanningTime;
var const config int MaxRandomUIScanningTime;
var const config int HardCoreMaxCP;
var private const string TokenTypeNames[4];
var private transient class<FoxPickup_Token> TokenTypeClasses[4];
var AkEvent SivSpawnSound;
var AkEvent DogSpawnSound;
var AkEvent HulkSpawnSound;
var const int SpawnSoundTriggerCount;
var const float SpawnSoundTriggerDistance;
var const config float TimeToRestoreSpawnUse;

function int GetWaveDelayTime()
{
    local int TotalScanTime;

    TotalScanTime = MinimumUIScanningTime + Rand(MaxRandomUIScanningTime + 1);
    // End:0x42
    if((TotalScanTime % 2) != 0)
    {
        TotalScanTime += 1;
    }
    CachedGRI.UIScanningTime = TotalScanTime;
    return (EstablishingScanningUIBufferTime + EstablishingProgressTime) + TotalScanTime;
    //return ReturnValue;    
}

simulated function NotifyLevelStreamedIn()
{
    super(FoxGame).NotifyLevelStreamedIn();
    InitializeGame();
    //return;    
}

private final function InitializeGame()
{
    local int I;
    local FoxGameSettingsCommon GameSettings;
    local int UsedDifficultyIndex;
    local FoxMapInfo_OS MapInfo;

    MapInfo = FoxMapInfo_OS(WorldInfo.GetMapInfoByType(class'FoxMapInfo_OS'));
    // End:0x5A
    if(Difficulty == 3)
    {
        UsedDifficultyIndex = 2;
    }
    // End:0x6D
    else
    {
        UsedDifficultyIndex = Difficulty;
    }
    // End:0x9D
    if(UsedDifficultyIndex >= MapInfo.Difficulties.Length)
    {
    }
    // End:0x44F
    else
    {
        WaveInfo = MapInfo.Difficulties[UsedDifficultyIndex].WaveInfo;
        CachedGRI.DifficultyLevel = byte(Difficulty);
        PrecomputeWaves();
        // End:0x307
        if(MenuItemsDataStore.HostMigrationInfo == none)
        {
            CachedGRI.TotalWaves = WaveInfo.Waves.Length;
            CachedGRI.CurrentWaveIndex = 0;
            CachedGRI.SubWaveIndex = 0;
            CachedGRI.LastCompletedWave = -1;
            CachedGRI.CurrentWaveKilledEnemies = 0;
            CachedGRI.CurrentWaveSpawnedEnemies = 0;
            CachedGRI.CurrentWaveTotalEnemies = 0;
            CachedGRI.UIEstablishingTime = EstablishingProgressTime;
            TimeLimit = MapInfo.Difficulties[UsedDifficultyIndex].TimeLimitMinutes;
            CachedGRI.RemainingMinute = TimeLimit;
            CachedGRI.RemainingTime = TimeLimit * 60;
            CreatePlayersJoinedArray();
        }
        WaveDelaySeconds = int(float(GetWaveDelayTime()) + 1.0);
        I = 0;
        J0x331:
        // End:0x393 [Loop If]
        if(I < 4)
        {
            TokenTypeClasses[I] = class<FoxPickup_Token>(DynamicLoadObject(TokenTypeNames[I], class'Class', true));
            ++ I;
            // [Loop Continue]
            goto J0x331;
        }
        CachedGRI.SetMutatorEnabled(14, Difficulty == 3);
        GameSettings = GetGameSettings();
        // End:0x421
        if(GameSettings != none)
        {
            GameSettings.SetMutatorSetting(CachedGRI.MutatorSetting);
        }
        // End:0x44F
        if(MenuItemsDataStore.HostMigrationInfo != none)
        {
            SetupFromHostMigration();
        }
    }
    //return;    
}

private final function CreatePlayersJoinedArray()
{
    local UniqueNetId ZeroId;
    local FoxPC FPC;
    local int I, ArraySize;

    ArraySize = 4;
    I = 0;
    J0x17:
    // End:0x6E [Loop If]
    if(I < ArraySize)
    {
        CachedGRI.PlayersJoined[I] = ZeroId;
        ++ I;
        // [Loop Continue]
        goto J0x17;
    }
    // End:0x25C
    foreach WorldInfo.AllControllers(class'FoxPC', FPC)
    {
        // End:0x25B
        if(FPC.PlayerReplicationInfo.UniqueId != ZeroId && !FPC.PlayerReplicationInfo.bIsSpectator)
        {
            I = 0;
            J0x130:
            // End:0x25B [Loop If]
            if(I < ArraySize)
            {
                // End:0x1B1
                if(CachedGRI.PlayersJoined[I] == FPC.PlayerReplicationInfo.UniqueId)
                {
                    // End:0x25B
                    continue;
                }
                // End:0x24D
                if(CachedGRI.PlayersJoined[I] == ZeroId)
                {
                    CachedGRI.PlayersJoined[I] = FPC.PlayerReplicationInfo.UniqueId;
                    // End:0x25B
                    continue;
                }
                ++ I;
                // [Loop Continue]
                goto J0x130;
            }
        }        
    }    
    //return;    
}

function UpdateCacheFromGameSettingsMidMatch()
{
    super(FoxGame).UpdateCacheFromGameSettingsMidMatch();
    // End:0x2D
    if(Difficulty == 3)
    {
        MaximumCP = HardCoreMaxCP;
    }
    //return;    
}

function SetupGameFromPlaylistInfo()
{
    local FoxDataStore_Playlists PlaylistDataStore;

    super(FoxGame).SetupGameFromPlaylistInfo();
    PlaylistDataStore = FoxDataStore_Playlists(class'UIInteraction'.static.GetDataStoreClient().FindDataStore('FoxPlaylists'));
    Difficulty = PlaylistDataStore.GetDifficultyLevel();
    // End:0xA8
    if(Difficulty == 3)
    {
        MaximumCP = HardCoreMaxCP;
    }
    //return;    
}

function ScoreValidKill(Controller Killer, Controller KilledPlayer)
{
    local FoxPRI FPRI, FPRI2;

    FPRI = FoxPRI(Killer.PlayerReplicationInfo);
    FPRI2 = FoxPRI(KilledPlayer.PlayerReplicationInfo);
    // End:0x1DB
    if(FPRI2 != none)
    {
        FPRI.Score += float(1);
        FPRI.Kills += 1;
        FPRI.TotalKills += 1;
        // End:0x199
        if((WorldInfo.bRanked == true) && FPRI2.IsValidPlayer())
        {
            IncrementRankedStat(FPRI.UniqueId.Uid, 0);
            IncrementRankedStat(FPRI2.UniqueId.Uid, 1);
        }
        FPRI.bForceNetUpdate = true;
        FPRI2.bForceNetUpdate = true;
    }
    //return;    
}

function Pawn SpawnDefaultPawnFor(Controller NewPlayer, NavigationPoint StartSpot)
{
    local Pawn NewPawn;

    NewPawn = super(FoxGame).SpawnDefaultPawnFor(NewPlayer, StartSpot);
    // End:0x91
    if((NewPawn != none) && FoxPC(NewPlayer) != none)
    {
        NewPawn.bReplicateHealthToAll = true;
        NewPawn.bAlwaysRelevant = true;
    }
    return NewPawn;
    //return ReturnValue;    
}

function ScoreKill(Controller Killer, Controller Victim)
{
    local FoxPRI VictimPRI;

    // End:0x73
    if((Killer == Victim) || Killer == none)
    {
        // End:0x70
        if((Victim != none) && Victim.PlayerReplicationInfo != none)
        {
            ScoreSuicide(Victim);
        }
    }
    // End:0x205
    else
    {
        // End:0x205
        if(Killer.PlayerReplicationInfo != none)
        {
            VictimPRI = FoxPRI(Victim.PlayerReplicationInfo);
            // End:0x202
            if(((VictimPRI != none) && !VictimPRI.bIsInactive) && !VictimPRI.bOnlySpectator)
            {
                // End:0x1E6
                if((FoxPawn_DeployableBase(Killer.Pawn) != none) && FoxPawn_DeployableBase(Killer.Pawn).OwningPlayer != none)
                {
                    ScoreValidKill(FoxPawn_DeployableBase(Killer.Pawn).OwningPlayer, Victim);
                }
                // End:0x202
                else
                {
                    ScoreValidKill(Killer, Victim);
                }
            }
        }
        // End:0x205
        else
        {
        }
    }
    //return;    
}

private final function SpawnNextWave()
{
    bFirstWaveSpawned = true;
    bAllowingRespawns = false;
    CachedGRI.bFirstWaveSpawned = bFirstWaveSpawned;
    // End:0xD5
    if((CachedGRI.CurrentWaveIndex >= 0) && CachedGRI.CurrentWaveIndex < WaveInfo.Waves.Length)
    {
        WaveStarted();
        SpawnNextSubWave();
        WaveDelaySeconds = GetWaveDelayTime();
        J0xD5:
    }
    // End:0xD5
    else
    {
    }
    //return;    
}

function PlayerStartVariables GetPSVs(bool bIsAmbush)
{
    // End:0x5C
    if(bIsAmbush)
    {
        return ((WaveInfo.bOverrideAmbushSpawn) ? WaveInfo.AmbushSpawnVarsOverride : default.PSV_Ambush);
    }
    // End:0xA8
    else
    {
        return ((WaveInfo.bOverrideInProgressSpawn) ? WaveInfo.InProgressSpawnVarsOverride : default.PSV_InProgress);
    }
    //return ReturnValue;    
}

private final function SpawnNextSubWave()
{
    local WaveInfo WaveToSpawn;
    local SubWaveInfo SubWaveToSpawn;
    local AIPool CurrentPool;
    local WaveEnemyQueue NewData;
    local int I, NextSubWaveIndex;
    local float ChangeDepotDelay, SubWaveDelay;

    WaveToSpawn = WaveInfo.Waves[CachedGRI.CurrentWaveIndex];
    NextSubWaveIndex = CachedGRI.SubWaveIndex + 1;
    ++ CurrentAISquadIdx;
    CurrentHealthModifier = GetHealthModifier();
    // End:0x721
    if(((NextSubWaveIndex >= 0) && NextSubWaveIndex < WaveToSpawn.SubWaves.Length) && CheckValidSubwave(WaveToSpawn.SubWaves[NextSubWaveIndex], WaveToSpawn.AIPoolIndex))
    {
        CachedGRI.SubWaveIndex = NextSubWaveIndex;
        CachedGRI.SubWaveNumEnemies = 0;
        SubWaveToSpawn = WaveToSpawn.SubWaves[CachedGRI.SubWaveIndex];
        CurrentPool = SubWaveToSpawn.AIPools[WaveToSpawn.AIPoolIndex];
        PSV_Current = GetPSVs(WaveToSpawn.SubWaves[CachedGRI.SubWaveIndex].AIPools[WaveToSpawn.AIPoolIndex].bAmbushWave);
        WaveInfo.Waves[CachedGRI.CurrentWaveIndex].SubWaves[CachedGRI.SubWaveIndex].AIPools[WaveToSpawn.AIPoolIndex].MaximumPointValue += float(WaveInfo.SubwaveExtraPointValuePerPlayer * CachedGRI.GetNumHumanPlayers());
        TotalAIPoolPointsThisSubWave = 0.0;
        SetTimer(1.0, true, 'AddPointsToPool');
        SetTimer(CurrentPool.SpawnRate + 0.010, true, 'QueueBotsFromPool');
        I = 0;
        J0x3D4:
        // End:0x5B0 [Loop If]
        if(I < SubWaveToSpawn.PrecomputedQueue.Length)
        {
            NewData.AIToSpawn = SubWaveToSpawn.PrecomputedQueue[I];
            NewData.EnemyData.bDropAmmo = Rand(AmmoDropRate) < 1;
            NewData.EnemyData.TokenClass = ChooseRandomToken(NewData.AIToSpawn.AIPresetName);
            NewData.EnemyData.PresetName = SubWaveToSpawn.PrecomputedQueue[I].AIPresetName;
            NewData.EnemyData.SquadIdx = CurrentAISquadIdx;
            SpawnQueue.AddItem(NewData);
            ++ I;
            // [Loop Continue]
            goto J0x3D4;
        }
        SubWaveDelay = SubWaveToSpawn.AIPools[WaveToSpawn.AIPoolIndex].WaveTime + 0.010;
        SetTimer(SubWaveDelay + 0.010, false, 'SpawnNextSubWave');
        // End:0x71E
        if(WaveInfo.bStartDepotsDisabled && SubWaveToSpawn.bChangeDepot)
        {
            ChangeDepotDelay = FClamp((SubWaveToSpawn.ChangeDepotWaveTimePct * SubWaveDelay) + ((SubWaveToSpawn.ChangeDepotRandomnessToleranceSec * 2.0) * (0.50 - FRand())), 0.0, SubWaveDelay);
            // End:0x714
            if(ChangeDepotDelay > 0.0)
            {
                SetTimer(ChangeDepotDelay + 0.010, false, 'ChangeDepot');
            }
            // End:0x71E
            else
            {
                ChangeDepot();
            }
        }
    }
    // End:0x735
    else
    {
        ClearTimer('AddPointsToPool');
    }
    //return;    
}

private final function WaveStarted()
{
    TriggerGlobalEventClass(class'FoxSeqEvent_OSWaveStarted', self);
    BroadcastDialog('C', name("Objective.Updated"));
    ResetSpawnUses();
    StartLiveStreamingModsAtWaveStart();
    CheckBeginLiveStreamVote();
    CachedGRI.WaveStarted(WaveInfo.Waves[CachedGRI.CurrentWaveIndex]);
    // End:0x10E
    if(CachedGRI.CurrentWaveIndex >= (WaveInfo.Waves.Length - 1))
    {
        BroadcastEvent(0, 49, true);
    }
    // End:0x11D
    else
    {
        BroadcastEvent(0, 48, true);
    }
    //return;    
}

private final function ResetSpawnUses()
{
    local PlayerStart PS;

    // End:0x55
    foreach WorldInfo.AllNavigationPoints(class'PlayerStart', PS)
    {
        PS.NumTimesUsed = 0;        
    }    
    //return;    
}

// Export UFoxGameMP_OS::execDisableWeaponDepots(FFrame&, void* const)
private native final function DisableWeaponDepots(optional bool bEnableRandom);

// Export UFoxGameMP_OS::execEnableRandomWeaponDepot(FFrame&, void* const)
private native final function EnableRandomWeaponDepot(optional bool bDisablePrevious);

private final function ChangeDepot()
{
    EnableRandomWeaponDepot(true);
    BroadcastEvent(0, 54);
    BroadcastEvent(0, 55);
    //return;    
}

private final function CheckWaveCompleted()
{
    // End:0x201
    if(((bFirstWaveSpawned && RemainingWaveEnemies.Length == 0) && CachedGRI.CurrentWaveKilledEnemies >= CachedGRI.CurrentWaveTotalEnemies) && !IsTimerActive('AddPointsToPool'))
    {
        ClearTimer('AddPointsToPool');
        ClearTimer('QueueBotsFromPool');
        ClearTimer('ChangeDepot');
        AIPoolPoints = 0.0;
        TriggerGlobalEventClass(class'FoxSeqEvent_OSWaveCompleted', self);
        BroadcastDialog('D', name("Objective.Updated"));
        CachedGRI.WaveCompleted();
        ReviveDeadPlayers();
        StopLiveStreamingModsAtWaveEnd();
        CheckEndLiveStreamVote();
        // End:0x1D2
        if(CachedGRI.CurrentWaveIndex >= WaveInfo.Waves.Length)
        {
            BroadcastEvent(0, 52, true);
            Teams[0].Score = 1.0;
            bCompletedAllWavesSuccessfully = true;
            StartEndGameTimer();
        }
        // End:0x201
        else
        {
            BroadcastEvent(0, 51, true);
            SetTimer(float(WaveDelaySeconds) + 0.010, false, 'SpawnNextWave');
        }
    }
    //return;    
}

private final function ReviveDeadPlayers()
{
    local FoxPC FPC;

    bAllowingRespawns = true;
    // End:0x17E
    foreach WorldInfo.AllControllers(class'FoxPC', FPC)
    {
        // End:0x17D
        if(FPC.MyFoxPawn == none)
        {
            // End:0x104
            if((FPC.MyDeadPawn != none) && FPC.MyDeadPawn.IsInjured())
            {
                FPC.bHasSyringe = true;
                FPC.ServerStartRevive();
                // End:0x17D
                continue;
            }
            // End:0x169
            if(FPC.bHasBeacon)
            {
                FPC.EnableRespawn();
                FPC.bRespawnReady = true;
                // End:0x17D
                continue;
            }
            TryRestartPlayer(FPC);
        }        
    }    
    //return;    
}

function bool CanControllerRestart(Controller C, optional out FoxTypes.EUnableToSpawnReason UnableToRestartReason)
{
    local bool NetIdAllowed;
    local FoxPC CurrentPlayer;

    NetIdAllowed = CachedGRI.IsNetIdAllowed(C.PlayerReplicationInfo.UniqueId);
    CurrentPlayer = FoxPC(C);
    // End:0xA8
    if((CurrentPlayer == none) || !NetIdAllowed)
    {
        UnableToRestartReason = 1;
        return false;
    }
    // End:0x109
    if((!CurrentPlayer.bHasSpawnedIn && !bFirstWaveSpawned) || bAllowingRespawns)
    {
        return super(FoxGame).CanControllerRestart(C, UnableToRestartReason);
    }
    UnableToRestartReason = 1;
    return false;
    //return ReturnValue;    
}

event Timer()
{
    // End:0x45
    if(CachedGRI.RemainingTime <= 0)
    {
        CachedGRI.bPointActive = false;
    }
    super(FoxGame).Timer();
    CheckAlivePlayers();
    //return;    
}

function AddPointsToPool()
{
    local WaveInfo CurrentWave;
    local SubWaveInfo CurrentSubWave;
    local AIPool CurrentPool;

    GetCurrentWaveInfo(CurrentWave, CurrentSubWave, CurrentPool);
    // End:0xC6
    if((TotalAIPoolPointsThisSubWave < CurrentPool.MaximumPointValue) || CurrentPool.MaximumPointValue == float(0))
    {
        AIPoolPoints += CurrentPool.AIPoolPointsPerSecond;
        TotalAIPoolPointsThisSubWave += CurrentPool.AIPoolPointsPerSecond;
    }
    // End:0xDA
    else
    {
        ClearTimer('AddPointsToPool');
    }
    //return;    
}

function QueueBotsFromPool()
{
    local WaveEnemyQueue NewData;
    local array<AIInfo> RandomAI;
    local WaveInfo CurrentWave;
    local SubWaveInfo CurrentSubWave;
    local AIPool CurrentPool;
    local int I;

    // End:0x15
    if(AIPoolPoints < 1.0)
    {
        return;
    }
    GetCurrentWaveInfo(CurrentWave, CurrentSubWave, CurrentPool);
    RandomAI = ChooseRandomAI(CurrentPool.RandomAI, AIPoolPoints);
    FoxGRI_OS(FGRI).EnemiesQueued(RandomAI.Length);
    I = 0;
    J0xB0:
    // End:0x253 [Loop If]
    if(I < RandomAI.Length)
    {
        NewData.AIToSpawn = RandomAI[I];
        NewData.EnemyData.bDropAmmo = Rand(AmmoDropRate) < 1;
        NewData.EnemyData.TokenClass = ChooseRandomToken(NewData.AIToSpawn.AIPresetName);
        NewData.EnemyData.PresetName = RandomAI[I].AIPresetName;
        NewData.EnemyData.SquadIdx = CurrentAISquadIdx;
        SpawnQueue.AddItem(NewData);
        ++ I;
        // [Loop Continue]
        goto J0xB0;
    }
    //return;    
}

private final function StartEndGameTimer()
{
    bGameEnded = true;
    // End:0x5A
    if(Teams[0].Score == float(0))
    {
        Teams[1].Score = 1.0;
    }
    SetTimer(2.0, false, 'EndGameTimer');
    //return;    
}

function TokensCollected(Pawn P, byte TokenType, int Num)
{
    CachedGRI.EarnedTokens[TokenType] += Num;
    //return;    
}

private final function EndGameTimer()
{
    EndGame(none, "Game Over");
    //return;    
}

function EndGame(PlayerReplicationInfo Winner, string Reason)
{
    local FoxPRI PRI;
    local int I, J;

    ClearTimer('UpdateSpawnQueue');
    ClearTimer('SpawnNextWave');
    ClearTimer('SpawnNextSubWave');
    ClearTimer('ChangeDepot');
    ClearTimer('AddPointsToPool');
    ClearTimer('QueueBotsFromPool');
    ClearTimer('ActivateObjectivePoint');
    ClearTimer('CheckObjectiveFailed');
    ClearTimer('ObjectiveReminder');
    KillRemainingAI();
    I = 0;
    J0xC9:
    // End:0x2F8 [Loop If]
    if(I < FGRI.PRIArray.Length)
    {
        PRI = FoxPRI(FGRI.PRIArray[I]);
        // End:0x2EA
        if((!PRI.bBot && !PRI.bOnlySpectator) && !PRI.bIsInactive)
        {
            // End:0x22D
            if(bCompletedAllWavesSuccessfully)
            {
                PRI.UnlockBitterEndAchievement();
                // End:0x22D
                if(PRI.bHostPRI)
                {
                    OnlineSub.PlayerInterface.UnlockAchievement(0, 13, 100.0);
                }
            }
            // End:0x2EA
            if(PRI.GameTypeStats != none)
            {
                J = 0;
                J0x25C:
                // End:0x2EA [Loop If]
                if(J < 3)
                {
                    FoxOnlineStatsWriteGameType_OS(PRI.GameTypeStats).AddTokens(byte(J), CachedGRI.EarnedTokens[J]);
                    ++ J;
                    // [Loop Continue]
                    goto J0x25C;
                }
            }
        }
        ++ I;
        // [Loop Continue]
        goto J0xC9;
    }
    super(FoxGame).EndGame(Winner, Reason);
    //return;    
}

reliable client simulated function UnlockBitterEndAchievement()
{
    OnlineSub.PlayerInterface.UnlockAchievement(0, 13, 100.0);
    //return;    
}

function SetupHeroPose()
{
    // End:0x1A
    if(ShouldShowHeroPose())
    {
        super(FoxGame).SetupHeroPose();
    }
    // End:0x41
    else
    {
        ClearTimer('DelayedBeginRoundEnd');
        SetTimer(15.0, false, 'DelayedBeginRoundEnd');
    }
    //return;    
}

function KillRemainingAI()
{
    local WaveEnemyData P;

    // End:0x43
    foreach RemainingWaveEnemies(P,)
    {
        P.EnemyPawn.Destroy();        
    }    
    RemainingWaveEnemies.Length = 0;
    //return;    
}

private final function CheckAlivePlayers()
{
    // End:0x22
    if(!MatchIsInProgress() || !bFirstWaveSpawned)
    {
        return;
    }
    // End:0x3E
    if((GetNumPlayersAlive(,, true)) == 0)
    {
        StartEndGameTimer();
    }
    //return;    
}

simulated event TeamInfo GetWinningTeamForGame()
{
    return Teams[((bCompletedAllWavesSuccessfully) ? 0 : 1)];
    //return ReturnValue;    
}

function Killed(Controller Killer, Controller KilledPlayer, Pawn KilledPawn, class<DamageType> TheDamageType)
{
    local int I;
    local FoxDataStore_AIPresets PresetDataStore;
    local FoxDataProvider_AIPresets FoundPreset;

    PresetDataStore = FoxDataStore_AIPresets(class'UIInteraction'.static.GetDataStoreClient().FindDataStore('AIPresets'));
    super(FoxGame).Killed(Killer, KilledPlayer, KilledPawn, TheDamageType);
    // End:0x2C7
    if((FoxPawn_DeployableBase(KilledPawn) == none) && KilledPlayer.IsA('AIController'))
    {
        I = 0;
        J0xC8:
        // End:0x2BD [Loop If]
        if(I < RemainingWaveEnemies.Length)
        {
            // End:0x2AF
            if(RemainingWaveEnemies[I].EnemyPawn == KilledPawn)
            {
                // End:0x23D
                if(((FoxPC(Killer) != none) && FoxPRI(Killer.PlayerReplicationInfo).GameTypeStats != none) && PresetDataStore.GetProviderByName(RemainingWaveEnemies[I].PresetName, FoundPreset))
                {
                    FoxOnlineStatsWriteGameType_OS(FoxPRI(Killer.PlayerReplicationInfo).GameTypeStats).AddKilledEnemy(FoundPreset.StatId);
                }
                ++ CachedGRI.CurrentWaveKilledEnemies;
                CheckDropToken(RemainingWaveEnemies[I]);
                CheckDropAmmo(RemainingWaveEnemies[I]);
                RemainingWaveEnemies.Remove(I, 1);
                // [Explicit Break]
                goto J0x2BD;
            }
            ++ I;
            J0x2BD:
            // [Loop Continue]
            goto J0xC8;
        }
        CheckWaveCompleted();
    }
    //return;    
}

function CheckDropAmmo(WaveEnemyData EnemyData)
{
    local FoxMagazinePickup FMP;

    // End:0x93
    if(EnemyData.bDropAmmo)
    {
        FMP = Spawn(class'FoxMagazinePickup',,, EnemyData.EnemyPawn.Location);
        FMP.SetupAmmoPickup();
    }
    //return;    
}

function CheckDropToken(WaveEnemyData EnemyData)
{
    // End:0x7E
    if(EnemyData.TokenClass != none)
    {
        Spawn(EnemyData.TokenClass,,, EnemyData.EnemyPawn.Location);
    }
    //return;    
}

function class<FoxPickup_Token> ChooseRandomToken(name PresetName)
{
    local int Choice, I;
    local TokenWeightPerPreset WeightInfo;

    // End:0x27
    if(WaveInfo.TokenWeights.Length == 0)
    {
        return none;
    }
    I = WaveInfo.TokenWeights.Find('PresetToOverride', PresetName);
    // End:0x83
    if(I == -1)
    {
        I = 0;
    }
    WeightInfo = WaveInfo.TokenWeights[I];
    Choice = Rand(WeightInfo.TotalWeight);
    I = 0;
    J0xE8:
    // End:0x1F2 [Loop If]
    if(I < WeightInfo.PresetWeights.Length)
    {
        // End:0x1A0
        if(Choice < WeightInfo.PresetWeights[I].Weight)
        {
            return TokenTypeClasses[WeightInfo.PresetWeights[I].TokenType];
        }
        Choice -= WeightInfo.PresetWeights[I].Weight;
        ++ I;
        // [Loop Continue]
        goto J0xE8;
    }
    return none;
    //return ReturnValue;    
}

function StartMatch()
{
    local FoxGameObject_WeaponDepot Depot;

    InitializeGame();
    super(FoxGame).StartMatch();
    // End:0x83
    if((WaveInfo != none) && WaveInfo.bStartDepotsDisabled)
    {
        // End:0x77
        foreach AllActors(class'FoxGameObject_WeaponDepot', Depot)
        {
            WeaponDepots.AddItem(Depot);            
        }        
        DisableWeaponDepots(true);
    }
    InitializeObjectives();
    //return;    
}

function StartBots()
{
    SetTimer(5.0, false, 'NotifyFirstWave');
    SetTimer(float(WaveDelaySeconds) + 0.010, false, 'SpawnNextWave');
    SetTimer(SpawnQueueRate + 0.010, true, 'UpdateSpawnQueue');
    //return;    
}

function InitGameReplicationInfo()
{
    local FoxGameSettingsCommon GameSettings;
    local int Diff;

    super.InitGameReplicationInfo();
    CachedGRI = FoxGRI_OS(GameReplicationInfo);
    GameSettings = GetGameSettings();
    // End:0x157
    if((GameSettings != none) && GameSettings.GetIntProperty(268435717, Diff))
    {
        switch(Diff)
        {
            // End:0xB6
            case 0:
                CachedGRI.DifficultyLevel = 0;
                // End:0x157
                break;
            // End:0xDE
            case 1:
                CachedGRI.DifficultyLevel = 1;
                // End:0x157
                break;
            // End:0x107
            case 2:
                CachedGRI.DifficultyLevel = 2;
                // End:0x157
                break;
            // End:0x130
            case 3:
                CachedGRI.DifficultyLevel = 3;
                // End:0x157
                break;
            // End:0xFFFF
            default:
                CachedGRI.DifficultyLevel = 0;
                // End:0x157
                break;
            }
    }
    CurrentAISquadIdx = 0;
    //return;    
}

private final function PrecomputeWaves()
{
    local WaveInfo Info;
    local SubWaveInfo subInfo;
    local AIPool CurrentPool;
    local int I, J, K;
    local array<AIInfo> RandomAI;
    local int AIPoolIndex;

    I = 0;
    J0x0B:
    // End:0x17B [Loop If]
    if(I < WaveInfo.TokenWeights.Length)
    {
        WaveInfo.TokenWeights[I].TotalWeight = 0;
        J = 0;
        J0x80:
        // End:0x16D [Loop If]
        if(J < WaveInfo.TokenWeights[I].PresetWeights.Length)
        {
            WaveInfo.TokenWeights[I].TotalWeight += WaveInfo.TokenWeights[I].PresetWeights[J].Weight;
            ++ J;
            // [Loop Continue]
            goto J0x80;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    I = 0;
    J0x186:
    // End:0x485 [Loop If]
    if(I < WaveInfo.Waves.Length)
    {
        Info = WaveInfo.Waves[I];
        AIPoolIndex = Rand(Info.SubWaves[0].AIPools.Length);
        WaveInfo.Waves[I].AIPoolIndex = AIPoolIndex;
        J = 0;
        J0x273:
        // End:0x477 [Loop If]
        if(J < Info.SubWaves.Length)
        {
            subInfo = Info.SubWaves[J];
            // End:0x2F2
            if(!CheckValidSubwave(subInfo, AIPoolIndex))
            {
                // [Explicit Break]
                goto J0x477;
            }
            CurrentPool = subInfo.AIPools[AIPoolIndex];
            WaveInfo.Waves[I].SubWaves[J].PrecomputedQueue.Length = 0;
            RandomAI = ChooseRandomAI(CurrentPool.RandomAI, CurrentPool.InitialAIPoolPointValue);
            K = 0;
            J0x3D4:
            // End:0x469 [Loop If]
            if(K < RandomAI.Length)
            {
                WaveInfo.Waves[I].SubWaves[J].PrecomputedQueue.AddItem(RandomAI[K]);
                ++ K;
                // [Loop Continue]
                goto J0x3D4;
            }
            ++ J;
            J0x477:
            // [Loop Continue]
            goto J0x273;
        }
        ++ I;
        // [Loop Continue]
        goto J0x186;
    }
    //return;    
}

function bool CheckValidSubwave(SubWaveInfo SubWave, int AIPoolIndex)
{
    return (AIPoolIndex < SubWave.AIPools.Length) && SubWave.AIPools[AIPoolIndex].RandomAI.Length > 0;
    //return ReturnValue;    
}

function bool MaxEnemiesAlive()
{
    local WaveInfo CurrentWave;

    CurrentWave = WaveInfo.Waves[CachedGRI.CurrentWaveIndex];
    return RemainingWaveEnemies.Length >= CurrentWave.MaxAliveEnemiesPerAIPool[CurrentWave.AIPoolIndex];
    //return ReturnValue;    
}

function NotifyFirstWave()
{
    BroadcastEvent(0, 47, true);
    //return;    
}

function int GetForcedTeam(Controller Other, int Team)
{
    local FoxPC ForPC;

    ForPC = FoxPC(Other);
    // End:0xC9
    if(ForPC != none)
    {
        // End:0xC4
        if(((CachedGRI != none) && !CachedGRI.IsAllowedListEmpty()) && !CachedGRI.IsNetIdAllowed(ForPC.PlayerReplicationInfo.UniqueId))
        {
            return FindSpectateTeam();
        }
        return 0;
    }
    // End:0x12B
    else
    {
        // End:0x10E
        if(FoxPRI(Other.PlayerReplicationInfo).IsValidPlayer())
        {
            return 1;
        }
        // End:0x12B
        else
        {
            return super.GetForcedTeam(Other, Team);
        }
    }
    //return ReturnValue;    
}

private final function array<AIInfo> ChooseRandomAI(const array<AIInfo> AIPool, out float PoolPointValue)
{
    local bool bResult;
    local int AIIndex;
    local array<AIInfo> OutArray;

    OutArray.Length = 0;
    bResult = true;
    // End:0xF8
    if((AIPool.Length > 0) && PoolPointValue > float(0))
    {
        J0x3B:
        // End:0xF8 [Loop If]
        if(bResult)
        {
            bResult = ChooseAIByPointValue(AIPool, OutArray, PoolPointValue, AIIndex);
            // End:0xE4
            if(bResult)
            {
                OutArray.AddItem(AIPool[AIIndex]);
                PoolPointValue -= float(AIPool[AIIndex].PointValue);
            }
            // End:0xF5
            else
            {
                // End:0xF5
                if(PoolPointValue > float(0))
                {
                }
            }
            // [Loop Continue]
            goto J0x3B;
        }
    }
    return OutArray;
    //return ReturnValue;    
}

private final function UpdateSpawnQueue()
{
    local WaveEnemyQueue HeadInfo;
    local FoxPawn SpawnedPawn;

    // End:0x2C4
    if((SpawnQueue.Length > 0) && !MaxEnemiesAlive())
    {
        HeadInfo = SpawnQueue[0];
        SpawnedPawn = SpawnAIBotByProviderName(HeadInfo.AIToSpawn.AIPresetName,,,, 1, HeadInfo.EnemyData.SquadIdx, false, false);
        // End:0x2C4
        if(SpawnedPawn != none)
        {
            // End:0x19B
            if(HeadInfo.AIToSpawn.bOverrideTargetingInfo)
            {
                FoxAIControllerInterface(SpawnedPawn.Controller).TargetInfo = HeadInfo.AIToSpawn.TargetingInfo;
                FoxAIControllerInterface(SpawnedPawn.Controller).bUseTargetInfo = true;
            }
            // End:0x235
            if(CurrentHealthModifier > float(0))
            {
                SpawnedPawn.HealthMax = int(float(SpawnedPawn.HealthMax) * CurrentHealthModifier);
                SpawnedPawn.Health = SpawnedPawn.HealthMax;
            }
            ++ CachedGRI.CurrentWaveSpawnedEnemies;
            HeadInfo.EnemyData.EnemyPawn = SpawnedPawn;
            RemainingWaveEnemies.AddItem(HeadInfo.EnemyData);
            SpawnQueue.Remove(0, 1);
        }
    }
    //return;    
}

private final function float GetHealthModifier()
{
    local int SpawnedNumPlayers;

    SpawnedNumPlayers = GetNumSpawnedInPlayers();
    switch(SpawnedNumPlayers)
    {
        // End:0x4B
        case 1:
            return WaveInfo.OnePlayerHealthModifier;
        // End:0x6F
        case 2:
            return WaveInfo.TwoPlayerHealthModifier;
        // End:0x93
        case 3:
            return WaveInfo.ThreePlayerHealthModifier;
        // End:0xB7
        case 4:
            return WaveInfo.FourPlayerHealthModifier;
        // End:0xFFFF
        default:
            return WaveInfo.FourPlayerHealthModifier;
    }
    //return ReturnValue;    
}

// Export UFoxGameMP_OS::execPlayAudioForPlayerStart(FFrame&, void* const)
protected native function PlayAudioForPlayerStart(FoxPawn FP, PlayerStart PS);

// Export UFoxGameMP_OS::execChooseAIByPointValue(FFrame&, void* const)
private native final function bool ChooseAIByPointValue(const out array<AIInfo> FromList, const array<AIInfo> ToList, float MaxPointValue, out int ChosenIndex);

// Export UFoxGameMP_OS::execEnforceMaxAITypeCount(FFrame&, void* const)
private native final function bool EnforceMaxAITypeCount(const array<AIInfo> CompList, const AIInfo ToCheck);

function HandleEndGameScoring()
{
    local array<FoxPRI> SortedPRIArray;
    local int I, FirstPlaceID, SecondPlaceID, ThirdPlaceID, ForthPlaceID;

    local FoxPRI PRI;
    local TeamInfo WinningTeam;

    WinningTeam = GetWinningTeamForGame();
    WinningTeam.bIsWinningTeam = true;
    WinningTeamIndex = WinningTeam.TeamIndex;
    FirstPlaceID = -1;
    SecondPlaceID = -1;
    ThirdPlaceID = -1;
    ForthPlaceID = -1;
    SortedPRIArray = FGRI.GetSortedPRIs(,, true);
    // End:0x128
    if(SortedPRIArray.Length >= 1)
    {
        FirstPlaceID = SortedPRIArray[0].PlayerID;
        SortedPRIArray[0].AddGamePoints(GPEarnedWinFirst);
    }
    // End:0x18D
    if(SortedPRIArray.Length >= 2)
    {
        SecondPlaceID = SortedPRIArray[1].PlayerID;
        SortedPRIArray[1].AddGamePoints(GPEarnedWinSecond);
    }
    // End:0x1F4
    if(SortedPRIArray.Length >= 3)
    {
        ThirdPlaceID = SortedPRIArray[2].PlayerID;
        SortedPRIArray[2].AddGamePoints(GPEarnedWinThird);
    }
    // End:0x25B
    if(SortedPRIArray.Length >= 4)
    {
        ForthPlaceID = SortedPRIArray[3].PlayerID;
        SortedPRIArray[3].AddGamePoints(GPEarnedWinForth);
    }
    I = 0;
    J0x266:
    // End:0x340 [Loop If]
    if(I < SortedPRIArray.Length)
    {
        SortedPRIArray[I].ScorePlacement = I;
        // End:0x332
        if(SortedPRIArray[I].GameTypeStats != none)
        {
            SortedPRIArray[I].GameTypeStats.SetPlayerRank(I + 1, SortedPRIArray.Length);
        }
        ++ I;
        // [Loop Continue]
        goto J0x266;
    }
    I = 0;
    J0x34B:
    // End:0x6ED [Loop If]
    if(I < FGRI.PRIArray.Length)
    {
        PRI = FoxPRI(FGRI.PRIArray[I]);
        // End:0x6DF
        if(!PRI.bIsInactive && !PRI.bBot || PRI.bPlayerBot)
        {
            PRI.bOnWinningTeam = PRI.Team.TeamIndex == WinningTeamIndex;
            // End:0x4F6
            if(PRI.GameTypeStats != none)
            {
                PRI.GameTypeStats.SetGameResult(PRI.bOnWinningTeam);
            }
            // End:0x5D5
            if(!PRI.bOnlySpectator)
            {
                PRI.MatchEndExperience = FoxGRI_OS(FGRI).GetCoopPostGameExperience(PRI.bOnWinningTeam);
                PRI.AddGamePoints(((PRI.bOnWinningTeam) ? GPEarnedGameWin : GPEarnedGameLose));
            }
            // End:0x635
            if(PRI.TotalCombatPointsEarned >= PRI.BigWinnerAchievementThreshold)
            {
                PRI.UnlockBigWinnerAchievement();
            }
            FoxPC(PRI.Owner).ClientNotifyOSGameEnd(byte(WinningTeamIndex), PRI.MatchEndExperience, byte(PRI.ScorePlacement), FirstPlaceID, SecondPlaceID, ThirdPlaceID, ForthPlaceID);
        }
        ++ I;
        // [Loop Continue]
        goto J0x34B;
    }
    FGRI.FirstPlaceID = FirstPlaceID;
    FGRI.SecondPlaceID = SecondPlaceID;
    FGRI.ThirdPlaceID = ThirdPlaceID;
    FGRI.ForthPlaceID = ForthPlaceID;
    //return;    
}

function bool ShouldShowHeroPose()
{
    return (GetWinningTeamForGame()) == Teams[0];
    //return ReturnValue;    
}

function bool CanJoinGame(bool bSpectator, UniqueNetId UniqueId, out string OutErrorMessage)
{
    return super(FoxGame).CanJoinGame(bSpectator, UniqueId, OutErrorMessage);
    //return ReturnValue;    
}

function bool CanJoinInProgress(bool bSpectator, UniqueNetId UniqueId)
{
    return ((bAllowJoinInProgress || !FGRI.bMatchHasBegun || !CachedGRI.IsAllowedListEmpty()) || bSpectator) || CachedGRI.IsNetIdAllowed(UniqueId);
    //return ReturnValue;    
}

function AddPlayerDeathLocation(Pawn DeadPawn, Controller KilledPlayer)
{
    local PlayerDeathLocation PDL;

    PDL.Location = DeadPawn.Location;
    PDL.ExpirationAmount = 15.0 + PSV_Current.AdditionalDeathLocationExpirationTime;
    PDL.ExpirationTime = WorldInfo.RealTimeSeconds + PDL.ExpirationAmount;
    PDL.TeamIndex = KilledPlayer.GetTeamNum();
    RecentPlayerDeathLocations[RecentPlayerDeathLocations.Length] = PDL;
    //return;    
}

function GetCurrentWaveInfo(out WaveInfo CurrentWave, out SubWaveInfo CurrentSubWave, out AIPool CurrentPool)
{
    CurrentWave = WaveInfo.Waves[CachedGRI.CurrentWaveIndex];
    CurrentSubWave = CurrentWave.SubWaves[CachedGRI.SubWaveIndex];
    CurrentPool = CurrentSubWave.AIPools[CurrentWave.AIPoolIndex];
    //return;    
}

function RecalculateHighestThreat()
{
    //return;    
}

function CalculateHighestThreat()
{
    //return;    
}

// Export UFoxGameMP_OS::execGetAIAccuracyModifier(FFrame&, void* const)
native function float GetAIAccuracyModifier();

// Export UFoxGameMP_OS::execGetAIDamageModifier(FFrame&, void* const)
native function float GetAIDamageModifier();

// Export UFoxGameMP_OS::execGetAIHealthModifier(FFrame&, void* const)
native function float GetAIHealthModifier();

function NotifyMultiKillEnded(FoxPRI ForPRI)
{
    ForPRI.MultiKills = 0;
    //return;    
}

function BroadcastKillSpreeMessage(Controller Killer, Controller Killed)
{
    //return;    
}

function StartInProgressSpawn()
{
    //return;    
}

// Export UFoxGameMP_OS::execRateForGameType(FFrame&, void* const)
native function float RateForGameType(PlayerStart P, Controller Player, const out PlayerStartVariables PSV);

function InitializeObjectives()
{
    local int DiffCount, I;

    CurrentObjectiveIndex = -1;
    ActivatedObjectiveCount = 0;
    DiffCount = WaveInfo.MaxNumberObjectives - WaveInfo.MinNumberObjectives;
    NumObjectives = ((DiffCount == 0) ? WaveInfo.MinNumberObjectives : WaveInfo.MinNumberObjectives + Rand(DiffCount + 1));
    I = 0;
    J0xD4:
    // End:0x141 [Loop If]
    if(I < Objectives.Length)
    {
        Objectives[I].PersistentUseGoalTime = WaveInfo.TimeToCapturePoint;
        ++ I;
        // [Loop Continue]
        goto J0xD4;
    }
    // End:0x173
    if((ActivatedObjectiveCount + 1) < NumObjectives)
    {
        SetTimer(GetNextObjectiveTimer(), false, 'ActivateObjectivePoint');
    }
    //return;    
}

function float GetNextObjectiveTimer()
{
    local float Diff;

    Diff = WaveInfo.MaxPointActivationTime - WaveInfo.MinPointActivationTime;
    return ((Diff == float(0)) ? WaveInfo.MaxPointActivationTime : WaveInfo.MinPointActivationTime + float(Rand(int(Diff + float(1)))));
    //return ReturnValue;    
}

function ActivateObjectivePoint()
{
    ++ ActivatedObjectiveCount;
    CachedGRI.ActivatedObjectiveCount = ActivatedObjectiveCount;
    CurrentObjectiveIndex = (Rand(Objectives.Length + 1) + 1) % Objectives.Length;
    Objectives[CurrentObjectiveIndex].ActivateServer(WaveInfo.TimeMustUseByPoint);
    CachedGRI.bPointActive = true;
    SetTimer(WaveInfo.TimeMustUseByPoint, false, 'CheckObjectiveFailed');
    SetTimer(15.0, true, 'ObjectiveReminder');
    BroadcastDialog('A', name("Objective.Updated"));
    //return;    
}

function ObjectiveReminder()
{
    // End:0x84
    if(Objectives[CurrentObjectiveIndex].bPointActive && !Objectives[CurrentObjectiveIndex].IsInUse())
    {
        BroadcastDialog('B', name("Objective.Updated"));
    }
    //return;    
}

function ObjectiveCompleted()
{
    CachedGRI.bPointActive = false;
    Objectives[CurrentObjectiveIndex].Deactivate();
    ClearTimer('ObjectiveReminder');
    //return;    
}

function CheckObjectiveFailed()
{
    ClearTimer('ObjectiveReminder');
    // End:0xD8
    if((!bGameEnded && CurrentObjectiveIndex >= 0) && CurrentObjectiveIndex < Objectives.Length)
    {
        // End:0xA6
        if(Objectives[CurrentObjectiveIndex].bPointActive)
        {
            EndGame(none, "Failed to complete objective");
        }
        // End:0xD8
        else
        {
            // End:0xD8
            if((ActivatedObjectiveCount + 1) < NumObjectives)
            {
                SetTimer(GetNextObjectiveTimer(), false, 'ActivateObjectivePoint');
            }
        }
    }
    //return;    
}

function RegisterObjective(FoxGameObject_OSPoint NewObjective)
{
    // End:0x36
    if(Objectives.Find(NewObjective) == -1)
    {
        Objectives.AddItem(NewObjective);
    }
    //return;    
}

function CheckBotCount()
{
    //return;    
}

function CheckKickVoteWithTeams()
{
    local int I;

    I = VoteKickList.Length - 1;
    J0x17:
    // End:0xA4 [Loop If]
    if(I >= 0)
    {
        // End:0x96
        if(VoteKickList[I].PlayersWhoWantToKick.Length >= (NumFriendlyVotesRequiredForKick + NumEnemyVotesRequiredForKick))
        {
            VoteKickPlayer(VoteKickList[I].PlayerToKick);
        }
        -- I;
        // [Loop Continue]
        goto J0x17;
    }
    //return;    
}

function SetupFromHostMigration()
{
    ActivatedObjectiveCount = CachedGRI.ActivatedObjectiveCount;
    bFirstWaveSpawned = CachedGRI.bFirstWaveSpawned;
    //return;    
}

function StartLiveStreamingModsAtWaveStart()
{
    local int I;
    local FoxPC FPC;
    local FoxPRI PRI;

    // End:0x18A
    foreach WorldInfo.AllControllers(class'FoxPC', FPC)
    {
        PRI = FoxPRI(FPC.PlayerReplicationInfo);
        // End:0x189
        if(PRI != none)
        {
            I = 0;
            J0x7F:
            // End:0x189 [Loop If]
            if(I < PRI.LiveStreamingMods.Length)
            {
                // End:0x17B
                if(!PRI.LiveStreamingMods[I].Finished() && !PRI.LiveStreamingMods[I].Running())
                {
                    PRI.LiveStreamingMods[I].Start(FPC);
                }
                ++ I;
                // [Loop Continue]
                goto J0x7F;
            }
        }        
    }    
    //return;    
}

function StopLiveStreamingModsAtWaveEnd()
{
    local int I;
    local FoxPC FPC;
    local FoxPRI PRI;

    // End:0x13A
    foreach WorldInfo.AllControllers(class'FoxPC', FPC)
    {
        PRI = FoxPRI(FPC.PlayerReplicationInfo);
        // End:0x139
        if(PRI != none)
        {
            I = 0;
            J0x7F:
            // End:0x139 [Loop If]
            if(I < PRI.LiveStreamingMods.Length)
            {
                // End:0x12B
                if(PRI.LiveStreamingMods[I].Running())
                {
                    PRI.LiveStreamingMods[I].End();
                }
                ++ I;
                // [Loop Continue]
                goto J0x7F;
            }
        }        
    }    
    //return;    
}

function CheckBeginLiveStreamVote()
{
    local FoxPC MyFoxPC;
    local FoxHudUI HudUI;
    local FoxPRI MyFoxPRI;

    MyFoxPC = FoxPC(GetALocalPlayerController());
    // End:0x17A
    if(MyFoxPC != none)
    {
        MyFoxPRI = FoxPRI(MyFoxPC.PlayerReplicationInfo);
        // End:0x17A
        if((MyFoxPRI != none) && MyFoxPRI.IsStreaming)
        {
            // End:0x17A
            if(MyFoxPC.DynamicUI != none)
            {
                HudUI = MyFoxPC.DynamicUI.HUD;
                // End:0x17A
                if((HudUI != none) && HudUI.LiveStreamModWidget != none)
                {
                    HudUI.LiveStreamModWidget.SetVisible(true);
                    MyFoxPRI.BeginVote();
                }
            }
        }
    }
    //return;    
}

function CheckEndLiveStreamVote()
{
    local FoxPC MyFoxPC;
    local FoxPRI MyFoxPRI;

    MyFoxPC = FoxPC(GetALocalPlayerController());
    // End:0xAF
    if(MyFoxPC != none)
    {
        MyFoxPRI = FoxPRI(MyFoxPC.PlayerReplicationInfo);
        // End:0xAF
        if((MyFoxPRI != none) && MyFoxPRI.IsStreaming)
        {
            MyFoxPRI.EndVote();
        }
    }
    //return;    
}

function bool IsMatchAlmostOver()
{
    return false;
    //return ReturnValue;    
}

defaultproperties
{
    WaveInfo=FoxAIWaveInfo'WaveArchetypes.Wave_Civ_5_Medium'
    CurrentHealthModifier=1.0
    PSV_Ambush=(NearByTeammateAdjustment=0.0,NearByTeammateDistThreshold=0.0,NearByTeammateZThreshold=0.0,VisibleTeammateAdjustment=0.0,BehindVisibleTeammateAdjustment=0.0,VisibleTeammateDistThreshold=0.0,NearBySquadmateAdjustment=0.0,NearBySquadmateDistThreshold=0.0,NearByCompetingSquadmateAdjustment=0.0,NearByCompetingSquadmateDistThreshold=0.0,NearByEnemyAdjustment=5.0,NearByEnemyDistThreshold=4096.0,VisibleEnemyAdjustment=5.0,VisibleEnemyDistThreshold=0.0,NearObjectiveAdjustment=0.0,NearObjectiveDistThreshold=0.0,SameTeamAdjustment=5.0,EnemyTeamAdjustment=-500.0,PrimaryStartAdjustment=0.0,DisabledAdjustment=0.0,RecentlySpawnedAdjustment=0.0,RecentlySpawnedTimeThreshold=1.0,CollidingPawnAdjustment=0.0,CollidingPawnCollisionRadiusMultiplier=0.0,AdditionalDeathLocationExpirationTime=0.0,DeathLocationAdjustment=-10.0,DeathLocationThreshold=1024.0,EqualScoreThreshold=5.0,SpawnAnimMatchAdjustment=100.0,SpawnAnimNoMatchAdjustment=0.0,SpawnUseAdjustment=-30.0)
    SpawnQueueRate=0.20
    AmmoDropRate=7
    EstablishingScanningUIBufferTime=11
    EstablishingProgressTime=2
    MinimumUIScanningTime=4
    MaxRandomUIScanningTime=6
    TokenTypeNames[1]="FoxGameContent_OS.FoxPickup_Token_OS_Bronze"
    TokenTypeNames[2]="FoxGameContent_OS.FoxPickup_Token_OS_Silver"
    TokenTypeNames[3]="FoxGameContent_OS.FoxPickup_Token_OS_Gold"
    SivSpawnSound=AkEvent'A_Onslaught.Play_Onslaught_Wave_Start'
    DogSpawnSound=AkEvent'A_Onslaught.Play_Onslaught_Dogs_Start'
    HulkSpawnSound=AkEvent'A_Onslaught.Play_Onslaught_Hulk_Start'
    SpawnSoundTriggerCount=4
    SpawnSoundTriggerDistance=1024.0
    TimeToRestoreSpawnUse=20.0
    PSV_InProgress=(NearByTeammateAdjustment=5.0,NearByTeammateDistThreshold=0.0,VisibleTeammateAdjustment=0.0,VisibleTeammateDistThreshold=0.0,NearByEnemyAdjustment=5.0,NearByEnemyDistThreshold=2048.0,VisibleEnemyAdjustment=1.0,VisibleEnemyDistThreshold=0.0,SameTeamAdjustment=5.0,EnemyTeamAdjustment=-500.0,RecentlySpawnedTimeThreshold=1.50,AdditionalDeathLocationExpirationTime=10.0,DeathLocationAdjustment=-10.0,DeathLocationThreshold=2048.0,EqualScoreThreshold=10.0,SpawnAnimMatchAdjustment=100.0,SpawnUseAdjustment=-30.0)
    LocStringTeam1Name="[A]BLACKLIGHT"
    LocStringTeam2Name="[B]HORDE"
    bAllowTeamChange=false
    bHideEnemyPlayerNames=true
    bAlwaysShowAllyHealth=true
    bForceTournamentMode=true
    bBlockSpectatingHosts=true
    bAlwaysInjure=true
    bDisplayAIDeathMessages=false
    GameTypeStatsClass=class'FoxOnlineStatsWriteGameType_OS'
    GameRespawnTime=30.0
    GameTypeString="Onslaught"
    GameTypeTooltip="Survive waves of enemies"
    GameTypeAbbreviatedName="OS"
    GameTypeScoreLabel=""
    RewardEligibilityMinTimePlayed=0.0
    RewardEligibilityMinMatchTime=0.0
    MaxRounds=1
    Difficulty=1
    PSV_Current=(NearByTeammateAdjustment=50.0,VisibleTeammateAdjustment=0.0,VisibleTeammateDistThreshold=0.0,NearByEnemyDistThreshold=512.0,VisibleEnemyAdjustment=0.0,VisibleEnemyDistThreshold=0.0,PrimaryStartAdjustment=500.0,AdditionalDeathLocationExpirationTime=10.0,EqualScoreThreshold=10.0,SpawnAnimMatchAdjustment=100.0)
    AllowedBoostTypes(0)=17
    AllowedBoostTypes(1)=35
    AllowedBoostTypes(2)=0
    AllowedBoostTypes(3)=0
    AllowedBoostTypes(4)=0
    AllowedBoostTypes(5)=0
    NumEnemyVotesRequiredForKick=0
    bCoopGame=true
    bSupportsBleedout=true
    HUDType=class'FoxHud_OS'
    MaxPlayers=4
    MaxPlayersAllowed=4
    GoalScore=100
    TimeLimit=30
    GameReplicationInfoClass=class'FoxGRI_OS'
    OnlineGameSettingsClass=class'FoxGameSettings_OS'
}